/* Trigger criada para gerar log das transaes na tabela GRUPGEREFASE */
CREATE OR REPLACE TRIGGER LOG_GRUPGEREFASE
AFTER DELETE OR INSERT
ON GRUPGEREFASE FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.CDGRUPGERENTEOP IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupGerente=' || :OLD.CDGRUPGERENTEOP;
      END IF;

      IF :OLD.CDFASEORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' Fase=' || :OLD.CDFASEORCOPERAC;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDGRUPGERENTEOP||';'||:OLD.CDFASEORCOPERAC;
   ELSE
      V_TIPO         := '1';
      V_ITPESQ       := :NEW.CDGRUPGERENTEOP||';'||:NEW.CDFASEORCOPERAC;

      IF :NEW.CDGRUPGERENTEOP IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupGerente=' || :NEW.CDGRUPGERENTEOP;
      END IF;

      IF :NEW.CDFASEORCOPERAC IS NOT NULL THEN
         V_DESC := V_DESC || ' Fase=' || :NEW.CDFASEORCOPERAC;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('GRUPGEREFASE',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GRUPGEREFASE','5.09.000'); END;
/

